#include <bits/stdc++.h>
typedef int_fast64_t lli;
using namespace std;
signed main() 
{
    ios_base::sync_with_stdio(NULL);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string s;
    cin >> s;
    vector<lli> ans(s.size(), 1e5);
    lli b = 0;
    for(lli i = 1; i < s.size(); i++)
    {
        if(s[i] < s[i-1]) ans[b] = i;
        else b = i;
    }
    lli t = 1e5;
    for(lli i = s.size()-1; i >= 0; i--) 
    {
        if(ans[i] != 1e5) t = ans[i];
        ans[i] = t;
    }
    lli q;
    cin >> q;
    for(lli i = 0; i < ans.size(); i++) cout << ans[i] << " ";
    cout << endl;
    while(q--)
    {
        lli a, b, c = 0;
        cin >> a >> b, a--, b--;
        while(a <= b)
        {
            c++;
            a = ans[a];
        }
        cout << c << endl;
    }     
}
